//+------------------------------------------------------------------+
//|                                             kostka_static_SL.mq4 |
//|                  Copyright 2017, Marcin Tuszkiewicz, investio.pl |
//|                                         https://investio.pl/mql4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Marcin Tuszkiewicz, investio.pl"
#property link      "https://investio.pl/mql4"
#property version   "1.00"
#property strict
//--- input parameters
input double   risk=0.001;
input int      ATR_period=9;
input double   SL=0.1;
input double   TP=0.5;
input bool     smart_direction=false;

double actual_ATR;
double actual_SL;
double actual_TP;
int direction, actual_direction;
double position_value;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
   
   if(OrdersTotal() == 0){
      actual_ATR = iATR(0, 0, ATR_period, 0);
      //odczytanie wyniku poprzedniej transakcji
      if(smart_direction == TRUE){
         int i = OrdersHistoryTotal();
         if(i > 0){
            if(OrderSelect(i, SELECT_BY_TICKET, MODE_HISTORY)){
               actual_direction = OrderType();
               if(OrderProfit() > 0){
                  direction = actual_direction;
               }else{
                  switch(actual_direction){
                     case OP_BUY : direction = OP_SELL; break;
                     case OP_SELL : direction = OP_BUY; break;
                  }
               }
               
               actual_SL = SL * actual_ATR;
               actual_TP = TP * actual_ATR;
               position_value = ((AccountBalance()*risk)/(actual_SL*MathPow(10, Digits)))/MarketInfo(0, MODE_TICKVALUE);
               if(direction == OP_BUY){
                  OrderSend(NULL,  direction, position_value, Ask, 2, Bid - actual_SL, Bid + actual_TP);
               }
               if(direction == OP_SELL){
                  OrderSend(NULL, direction, position_value, Bid, 2, Ask + actual_SL, Ask - actual_TP);
               }
               
            }          
         }else{
            actual_SL = SL * actual_ATR;
            actual_TP = TP * actual_ATR;
            position_value = ((AccountBalance()*risk)/(actual_SL*MathPow(10, Digits)))/MarketInfo(0, MODE_TICKVALUE);
            if(MathMod(MathRand(),2) == 0){
               direction = OP_BUY;
               OrderSend(NULL,  direction, position_value, Ask, 2, Bid - actual_SL, Bid + actual_TP);
            }else{
               direction = OP_SELL;
               OrderSend(NULL, direction, position_value, Bid, 2, Ask + actual_SL, Ask - actual_TP);
            }
              
         }
      }else{
         actual_SL = SL * actual_ATR;
         actual_TP = TP * actual_ATR;
         position_value = ((AccountBalance()*risk)/(actual_SL*MathPow(10, Digits)))/MarketInfo(0, MODE_TICKVALUE);
         if(MathMod(MathRand(),2) == 0){
            direction = OP_BUY;
            OrderSend(NULL,  direction, position_value, Ask, 2, Bid - actual_SL, Bid + actual_TP);
         }else{
            direction = OP_SELL;
            OrderSend(NULL, direction, position_value, Bid, 2, Ask + actual_SL, Ask - actual_TP);
         }
         
      }
   }   
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
